
/+ dub.sdl:
	name "dsp_output"
	dependency "dplug:core" version="*"
+/
module dsp_output;
/* ------------------------------------------------------------
author: "Oren Kurtz"
copyright: "Punk Labs LLC 2022"
license: "GPLv3-or-later"
name: "OneTrick SIMIAN"
version: "1.00f"
Code generated with Faust 2.40f.3 (https://faust.grame.fr)
Compilation options: -a custom.d.template -lang dlang -cn DSP_Output -pn processOutput -es 1 -mcd 16 -single -ftz 0
------------------------------------------------------------ */
/************************************************************************
 IMPORTANT NOTE : this file contains two clearly delimited sections :
 the ARCHITECTURE section (in two parts) and the USER section. Each section
 is governed by its own copyright and license. Please check individually
 each section for license and copyright information.
 *************************************************************************/

/*******************BEGIN ARCHITECTURE SECTION (part 1/2)****************/

/************************************************************************
 FAUST Architecture File
 Copyright (C) 2003-2019 GRAME, Centre National de Creation Musicale
 ---------------------------------------------------------------------
 This Architecture section is free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 3 of
 the License, or (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; If not, see <http://www.gnu.org/licenses/>.
 
 EXCEPTION : As a special exception, you may create a larger work
 that contains this FAUST architecture section and distribute
 that work under terms of your choice, so long as this FAUST
 architecture section is not modified.
 
 ************************************************************************
 ************************************************************************/

import std.math;
import std.stdio;
import std.conv;
import std.algorithm;
import std.format;
import core.stdc.stdlib;

/******************************************************************************
 *******************************************************************************
 
 VECTOR INTRINSICS
 
 *******************************************************************************
 *******************************************************************************/


/********************END ARCHITECTURE SECTION (part 1/2)****************/

/**************************BEGIN USER SECTION **************************/

/*
   ┏━━━┓╱╱╱╱╱┏┓╱╱┏┓╱╱╱╱╱┏┓╱╱   
   ┃┏━┓┃╱╱╱╱╱┃┃╱╱┃┃╱╱╱╱╱┃┃╱╱╱  
   ┃┗━┛┣┓┏┳━━┫┃┏┓┃┃╱╱┏━━┫┗━┳━━┓
   ┃┏━━┫┃┃┃┏┓┃┗┛┃┃┃╱┏┫┏┓┃┏┓┃━━┫
   ┃┃╱╱┃┗┛┃┃┃┃┏┓┃┃┗━┛┃┏┓┃┗┛┣━━┃
   ┗┛╱╱┗━━┻┛┗┻┛┗┛┗━━━┻┛┗┻━━┻━━┛
    ━━━━━━━━━━━━━━━━━━━━━━━━━━ 

	Copyright (c) 2022 Punk Labs LLC

	This section is part of OneTrick SIMIAN

	OneTrick SIMIAN is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation, either version 3 of the License, or (at your option)
	any later version.

	OneTrick SIMIAN is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	OneTrick SIMIAN.  If not, see <http://www.gnu.org/licenses/>.
*/

import punklabs.faust.common;
import ldc.attributes; //fastmath

import std.math;
import std.algorithm : min, max;
import dplug.core.nogc: mallocNew, mallocSlice, destroyFree, assumeNothrowNoGC;
alias FAUSTCLASS = DSP_Output;
static float DSP_Output_faustpower2_f(float value) nothrow @nogc {
	return (value * value);
}

class DSP_Output : dsp
{
nothrow:
@nogc:
	
 private:
	
	FAUSTFLOAT fHslider0;
	FAUSTFLOAT fCheckbox0;
	float[2] fVec0;
	float[2] fRec0;
	FAUSTFLOAT fHslider1;
	float[2] fRec1;
	int fSampleRate;
	float fConst3;
	float fConst4;
	float fConst5;
	float fConst7;
	int IOTA0;
	float[2048] fVec1;
	FAUSTFLOAT fHslider2;
	float[2] fRec13;
	float[2] fRec14;
	float[1024] fVec2;
	float[2] fRec15;
	float[2] fRec16;
	float[1024] fVec3;
	float[2] fRec17;
	float[2] fRec18;
	float[1024] fVec4;
	float[2] fRec19;
	float[2] fRec20;
	float[128] fVec5;
	float[2] fRec11;
	float[64] fVec6;
	float[2] fRec9;
	float[12] fVec7;
	float[2] fRec7;
	float fConst8;
	float fConst9;
	float[3] fRec6;
	float fConst10;
	float[3] fRec21;
	float[2] fRec5;
	FAUSTFLOAT fHslider3;
	int[2] iVec8;
	int iConst11;
	int[2] iRec22;
	float fConst12;
	float[2] fRec3;
	float[2] fRec2;
	float fConst13;
	float fConst14;
	float fConst15;
	float fConst16;
	float[2] fRec25;
	float[2] fRec24;
	float[2] fRec23;
	FAUSTFLOAT fHslider4;
	float[2] fRec26;
	
 public:
	
	void metadata(Meta* m) nothrow @nogc { 
		m.declare("analyzers.lib/name", "Faust Analyzer Library");
		m.declare("analyzers.lib/version", "0.1f");
		m.declare("author", "Oren Kurtz");
		m.declare("basics.lib/name", "Faust Basic Element Library");
		m.declare("basics.lib/version", "0.5f");
		m.declare("compile_options", "-a custom.d.template -lang dlang -cn DSP_Output -pn processOutput -es 1 -mcd 16 -single -ftz 0");
		m.declare("compressors.lib/compression_gain_mono:author", "Julius O. Smith III");
		m.declare("compressors.lib/compression_gain_mono:copyright", "Copyright (C) 2014-2020 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("compressors.lib/compression_gain_mono:license", "MIT-style STK-4.3f license");
		m.declare("compressors.lib/compressor_stereo:author", "Julius O. Smith III");
		m.declare("compressors.lib/compressor_stereo:copyright", "Copyright (C) 2014-2020 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("compressors.lib/compressor_stereo:license", "MIT-style STK-4.3f license");
		m.declare("compressors.lib/name", "Faust Compressor Effect Library");
		m.declare("compressors.lib/version", "0.2f");
		m.declare("copyright", "Punk Labs LLC 2022");
		m.declare("delays.lib/name", "Faust Delay Library");
		m.declare("delays.lib/version", "0.1f");
		m.declare("filename", "Simian.dsp");
		m.declare("filters.lib/allpass_comb:author", "Julius O. Smith III");
		m.declare("filters.lib/allpass_comb:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/allpass_comb:license", "MIT-style STK-4.3f license");
		m.declare("filters.lib/fb_comb:author", "Julius O. Smith III");
		m.declare("filters.lib/fb_comb:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/fb_comb:license", "MIT-style STK-4.3f license");
		m.declare("filters.lib/fir:author", "Julius O. Smith III");
		m.declare("filters.lib/fir:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/fir:license", "MIT-style STK-4.3f license");
		m.declare("filters.lib/highpass:author", "Julius O. Smith III");
		m.declare("filters.lib/highpass:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/iir:author", "Julius O. Smith III");
		m.declare("filters.lib/iir:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/iir:license", "MIT-style STK-4.3f license");
		m.declare("filters.lib/lowpass0_highpass1", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/lowpass0_highpass1:author", "Julius O. Smith III");
		m.declare("filters.lib/name", "Faust Filters Library");
		m.declare("filters.lib/rev1:author", "Julius O. Smith III");
		m.declare("filters.lib/rev1:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/rev1:license", "MIT-style STK-4.3f license");
		m.declare("filters.lib/rev2:author", "Julius O. Smith III");
		m.declare("filters.lib/rev2:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/rev2:license", "MIT-style STK-4.3f license");
		m.declare("filters.lib/tf2:author", "Julius O. Smith III");
		m.declare("filters.lib/tf2:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf2:license", "MIT-style STK-4.3f license");
		m.declare("filters.lib/tf2s:author", "Julius O. Smith III");
		m.declare("filters.lib/tf2s:copyright", "Copyright (C) 2003-2019 by Julius O. Smith III <jos@ccrma.stanford.edu>");
		m.declare("filters.lib/tf2s:license", "MIT-style STK-4.3f license");
		m.declare("filters.lib/version", "0.3f");
		m.declare("interpolators.lib/name", "Faust Interpolator Library");
		m.declare("interpolators.lib/version", "0.3f");
		m.declare("license", "GPLv3-or-later");
		m.declare("maths.lib/author", "GRAME");
		m.declare("maths.lib/copyright", "GRAME");
		m.declare("maths.lib/license", "LGPL with exception");
		m.declare("maths.lib/name", "Faust Math Library");
		m.declare("maths.lib/version", "2.5f");
		m.declare("misceffects.lib/name", "Misc Effects Library");
		m.declare("misceffects.lib/version", "2.0f");
		m.declare("name", "OneTrick SIMIAN");
		m.declare("options", "[midi:on]");
		m.declare("platform.lib/name", "Generic Platform Library");
		m.declare("platform.lib/version", "0.2f");
		m.declare("signals.lib/name", "Faust Signal Routing Library");
		m.declare("signals.lib/version", "0.1f");
		m.declare("version", "1.00f");
	}

	int getNumInputs() nothrow @nogc {
		return 3;
	}
	int getNumOutputs() nothrow @nogc {
		return 2;
	}
	
	static void classInit(int sample_rate) nothrow @nogc {
	}
	
	void instanceConstants(int sample_rate) nothrow @nogc {
		fSampleRate = sample_rate;
		float fConst0 = fmin(192000.0f, fmax(1.0f, cast(float)fSampleRate));
		float fConst1 = tan((942.477783f / fConst0));
		float fConst2 = (1.0f / fConst1);
		fConst3 = (1.0f / (((fConst2 + 1.41421354f) / fConst1) + 1.0f));
		fConst4 = exp((0.0f - (10000.0f / fConst0)));
		fConst5 = (1.0f - fConst4);
		float fConst6 = DSP_Output_faustpower2_f(fConst1);
		fConst7 = (1.0f / fConst6);
		fConst8 = (((fConst2 + -1.41421354f) / fConst1) + 1.0f);
		fConst9 = (2.0f * (1.0f - fConst7));
		fConst10 = (0.0f - (2.0f / fConst6));
		iConst11 = cast(int)(0.100000001f * fConst0);
		fConst12 = exp((0.0f - (50.0f / fConst0)));
		fConst13 = exp((0.0f - (100000.0f / fConst0)));
		fConst14 = (1.0f - fConst13);
		fConst15 = exp((0.0f - (50000.0f / fConst0)));
		fConst16 = exp((0.0f - (20.0f / fConst0)));
	}
	
	void instanceResetUserInterface() nothrow @nogc {
		fHslider0 = cast(FAUSTFLOAT)0.0f;
		fCheckbox0 = cast(FAUSTFLOAT)0.0f;
		fHslider1 = cast(FAUSTFLOAT)-6.0f;
		fHslider2 = cast(FAUSTFLOAT)50.0f;
		fHslider3 = cast(FAUSTFLOAT)-100.0f;
		fHslider4 = cast(FAUSTFLOAT)0.0f;
	}
	
	void instanceClear() nothrow @nogc {
		for (int l0 = 0; (l0 < 2); l0 = (l0 + 1)) {
			fVec0[l0] = 0.0f;
		}
		for (int l1 = 0; (l1 < 2); l1 = (l1 + 1)) {
			fRec0[l1] = 0.0f;
		}
		for (int l2 = 0; (l2 < 2); l2 = (l2 + 1)) {
			fRec1[l2] = 0.0f;
		}
		IOTA0 = 0;
		for (int l3 = 0; (l3 < 2048); l3 = (l3 + 1)) {
			fVec1[l3] = 0.0f;
		}
		for (int l4 = 0; (l4 < 2); l4 = (l4 + 1)) {
			fRec13[l4] = 0.0f;
		}
		for (int l5 = 0; (l5 < 2); l5 = (l5 + 1)) {
			fRec14[l5] = 0.0f;
		}
		for (int l6 = 0; (l6 < 1024); l6 = (l6 + 1)) {
			fVec2[l6] = 0.0f;
		}
		for (int l7 = 0; (l7 < 2); l7 = (l7 + 1)) {
			fRec15[l7] = 0.0f;
		}
		for (int l8 = 0; (l8 < 2); l8 = (l8 + 1)) {
			fRec16[l8] = 0.0f;
		}
		for (int l9 = 0; (l9 < 1024); l9 = (l9 + 1)) {
			fVec3[l9] = 0.0f;
		}
		for (int l10 = 0; (l10 < 2); l10 = (l10 + 1)) {
			fRec17[l10] = 0.0f;
		}
		for (int l11 = 0; (l11 < 2); l11 = (l11 + 1)) {
			fRec18[l11] = 0.0f;
		}
		for (int l12 = 0; (l12 < 1024); l12 = (l12 + 1)) {
			fVec4[l12] = 0.0f;
		}
		for (int l13 = 0; (l13 < 2); l13 = (l13 + 1)) {
			fRec19[l13] = 0.0f;
		}
		for (int l14 = 0; (l14 < 2); l14 = (l14 + 1)) {
			fRec20[l14] = 0.0f;
		}
		for (int l15 = 0; (l15 < 128); l15 = (l15 + 1)) {
			fVec5[l15] = 0.0f;
		}
		for (int l16 = 0; (l16 < 2); l16 = (l16 + 1)) {
			fRec11[l16] = 0.0f;
		}
		for (int l17 = 0; (l17 < 64); l17 = (l17 + 1)) {
			fVec6[l17] = 0.0f;
		}
		for (int l18 = 0; (l18 < 2); l18 = (l18 + 1)) {
			fRec9[l18] = 0.0f;
		}
		for (int l19 = 0; (l19 < 12); l19 = (l19 + 1)) {
			fVec7[l19] = 0.0f;
		}
		for (int l20 = 0; (l20 < 2); l20 = (l20 + 1)) {
			fRec7[l20] = 0.0f;
		}
		for (int l21 = 0; (l21 < 3); l21 = (l21 + 1)) {
			fRec6[l21] = 0.0f;
		}
		for (int l22 = 0; (l22 < 3); l22 = (l22 + 1)) {
			fRec21[l22] = 0.0f;
		}
		for (int l23 = 0; (l23 < 2); l23 = (l23 + 1)) {
			fRec5[l23] = 0.0f;
		}
		for (int l24 = 0; (l24 < 2); l24 = (l24 + 1)) {
			iVec8[l24] = 0;
		}
		for (int l25 = 0; (l25 < 2); l25 = (l25 + 1)) {
			iRec22[l25] = 0;
		}
		for (int l26 = 0; (l26 < 2); l26 = (l26 + 1)) {
			fRec3[l26] = 0.0f;
		}
		for (int l27 = 0; (l27 < 2); l27 = (l27 + 1)) {
			fRec2[l27] = 0.0f;
		}
		for (int l28 = 0; (l28 < 2); l28 = (l28 + 1)) {
			fRec25[l28] = 0.0f;
		}
		for (int l29 = 0; (l29 < 2); l29 = (l29 + 1)) {
			fRec24[l29] = 0.0f;
		}
		for (int l30 = 0; (l30 < 2); l30 = (l30 + 1)) {
			fRec23[l30] = 0.0f;
		}
		for (int l31 = 0; (l31 < 2); l31 = (l31 + 1)) {
			fRec26[l31] = 0.0f;
		}
	}
	
	void initialize(int sample_rate) nothrow @nogc {
		classInit(sample_rate);
		instanceInit(sample_rate);
	}
	void instanceInit(int sample_rate) nothrow @nogc {
		instanceConstants(sample_rate);
		instanceResetUserInterface();
		instanceClear();
	}
	
	DSP_Output clone() {
		return (mallocNew!DSP_Output());
	}
	
	int getSampleRate() nothrow @nogc {
		return fSampleRate;
	}
	
	void buildUserInterface(UI* uiInterface) nothrow @nogc {
		uiInterface.openVerticalBox("OneTrick SIMIAN");
		uiInterface.openTabBox("Globals");
		uiInterface.openVerticalBox("Globals");
		uiInterface.declare(&fHslider0, "0", "");
		uiInterface.addHorizontalSlider("Gain_Global", &fHslider0, cast(FAUSTFLOAT)0.0f, cast(FAUSTFLOAT)-100.0f, cast(FAUSTFLOAT)6.0f, cast(FAUSTFLOAT)0.100000001f);
		uiInterface.declare(&fHslider1, "1", "");
		uiInterface.addHorizontalSlider("Drive_Global", &fHslider1, cast(FAUSTFLOAT)-6.0f, cast(FAUSTFLOAT)-100.0f, cast(FAUSTFLOAT)6.0f, cast(FAUSTFLOAT)0.100000001f);
		uiInterface.declare(&fHslider2, "2", "");
		uiInterface.addHorizontalSlider("ReverbDecay_Global", &fHslider2, cast(FAUSTFLOAT)50.0f, cast(FAUSTFLOAT)0.0f, cast(FAUSTFLOAT)100.0f, cast(FAUSTFLOAT)0.00999999978f);
		uiInterface.declare(&fHslider3, "3", "");
		uiInterface.addHorizontalSlider("ReverbGate_Global", &fHslider3, cast(FAUSTFLOAT)-100.0f, cast(FAUSTFLOAT)-100.0f, cast(FAUSTFLOAT)0.0f, cast(FAUSTFLOAT)0.00999999978f);
		uiInterface.declare(&fHslider4, "5", "");
		uiInterface.addHorizontalSlider("Saturation_Global", &fHslider4, cast(FAUSTFLOAT)0.0f, cast(FAUSTFLOAT)0.0f, cast(FAUSTFLOAT)100.0f, cast(FAUSTFLOAT)0.00999999978f);
		uiInterface.closeBox();
		uiInterface.closeBox();
		uiInterface.addCheckButton("WakeUp", &fCheckbox0);
		uiInterface.closeBox();
	}
	
	void compute(int count, FAUSTFLOAT*[] inputs, FAUSTFLOAT*[] outputs) nothrow @nogc {
		FAUSTFLOAT* input0 = inputs[0];
		FAUSTFLOAT* input1 = inputs[1];
		FAUSTFLOAT* input2 = inputs[2];
		FAUSTFLOAT* output0 = outputs[0];
		FAUSTFLOAT* output1 = outputs[1];
		float fSlow0 = FastMath.pow(10.0f, (0.0500000007f * cast(float)fHslider0));
		float fSlow1 = cast(float)fCheckbox0;
		float fSlow2 = FastMath.pow(10.0f, (0.0500000007f * cast(float)fHslider1));
		float fSlow3 = ((0.00749999983f * cast(float)fHslider2) + 0.25f);
		int iSlow4 = cast(int)((1123.0f * fSlow3) + -1.0f);
		int iSlow5 = cast(int)((1011.0f * fSlow3) + -1.0f);
		int iSlow6 = cast(int)((901.0f * fSlow3) + -1.0f);
		int iSlow7 = cast(int)((778.0f * fSlow3) + -1.0f);
		float fSlow8 = FastMath.pow(10.0f, (0.0500000007f * cast(float)fHslider3));
		float fSlow9 = (0.00999999978f * cast(float)fHslider4);
		for (int i0 = 0; (i0 < count); i0 = (i0 + 1)) {
			fVec0[0] = fSlow1;
			float fTemp0 = cast(float)(fSlow1 <= fVec0[1]);
			float fTemp1 = (1.0f - (0.999499977f * fTemp0));
			fRec0[0] = ((fSlow0 * fTemp1) + (0.999499977f * (fTemp0 * fRec0[1])));
			fRec1[0] = ((fSlow2 * fTemp1) + (0.999499977f * (fTemp0 * fRec1[1])));
			float fTemp2 = (0.200000003f * cast(float)input2[i0]);
			float fTemp3 = (fTemp2 + (0.763999999f * fRec13[1]));
			fVec1[(IOTA0 & 2047)] = fTemp3;
			fRec13[0] = fVec1[((IOTA0 - iSlow4) & 2047)];
			fRec14[0] = fTemp3;
			float fTemp4 = (fTemp2 + (0.782999992f * fRec15[1]));
			fVec2[(IOTA0 & 1023)] = fTemp4;
			fRec15[0] = fVec2[((IOTA0 - iSlow5) & 1023)];
			fRec16[0] = fTemp4;
			float fTemp5 = (fTemp2 + (0.805000007f * fRec17[1]));
			fVec3[(IOTA0 & 1023)] = fTemp5;
			fRec17[0] = fVec3[((IOTA0 - iSlow6) & 1023)];
			fRec18[0] = fTemp5;
			float fTemp6 = ((0.827000022f * fRec19[1]) + fTemp2);
			fVec4[(IOTA0 & 1023)] = fTemp6;
			fRec19[0] = fVec4[((IOTA0 - iSlow7) & 1023)];
			fRec20[0] = fTemp6;
			float fTemp7 = (fRec14[1] + (fRec16[1] + (fRec18[1] + ((0.699999988f * fRec11[1]) + fRec20[1]))));
			fVec5[(IOTA0 & 127)] = fTemp7;
			fRec11[0] = fVec5[((IOTA0 - 124) & 127)];
			float fRec12 = (0.0f - (0.699999988f * fTemp7));
			float fTemp8 = (fRec11[1] + (fRec12 + (0.699999988f * fRec9[1])));
			fVec6[(IOTA0 & 63)] = fTemp8;
			fRec9[0] = fVec6[((IOTA0 - 41) & 63)];
			float fRec10 = (0.0f - (0.699999988f * fTemp8));
			float fTemp9 = (fRec9[1] + (fRec10 + (0.699999988f * fRec7[1])));
			fVec7[0] = fTemp9;
			fRec7[0] = fVec7[11];
			float fRec8 = (0.0f - (0.699999988f * fTemp9));
			float fTemp10 = (fRec8 + fRec7[1]);
			fRec6[0] = (fTemp10 - (fConst3 * ((fConst8 * fRec6[2]) + (fConst9 * fRec6[1]))));
			float fTemp11 = (((fConst7 * fRec6[0]) + (fConst10 * fRec6[1])) + (fConst7 * fRec6[2]));
			fRec21[0] = (0.0f - (fTemp10 + (fConst3 * ((fConst8 * fRec21[2]) + (fConst9 * fRec21[1])))));
			float fTemp12 = (((fConst7 * fRec21[0]) + (fConst10 * fRec21[1])) + (fConst7 * fRec21[2]));
			fRec5[0] = ((fConst5 * fabs((fabs((fConst3 * fTemp11)) + fabs((fConst3 * fTemp12))))) + (fConst4 * fRec5[1]));
			float fRec4 = fRec5[0];
			int iTemp13 = (fRec4 > fSlow8);
			iVec8[0] = iTemp13;
			iRec22[0] = max(cast(int)(iConst11 * (iTemp13 < iVec8[1])), cast(int)(iRec22[1] + -1));
			float fTemp14 = fmax(cast(float)iTemp13, cast(float)(iRec22[0] > 0));
			float fTemp15 = (((fRec2[1] > fTemp14)) ? fConst12 : fConst4);
			fRec3[0] = ((fTemp14 * (1.0f - fTemp15)) + (fTemp15 * fRec3[1]));
			fRec2[0] = fRec3[0];
			float fTemp16 = (fRec1[0] * (cast(float)input0[i0] + (fConst3 * (fRec2[0] * fTemp11))));
			float fTemp17 = (fRec1[0] * (cast(float)input1[i0] + (fConst3 * (fRec2[0] * fTemp12))));
			float fTemp18 = fabs((fabs(fTemp16) + fabs(fTemp17)));
			float fTemp19 = (((fRec24[1] > fTemp18)) ? fConst16 : fConst15);
			fRec25[0] = ((fTemp18 * (1.0f - fTemp19)) + (fTemp19 * fRec25[1]));
			fRec24[0] = fRec25[0];
			fRec23[0] = ((fConst14 * (0.0f - (0.949999988f * fmax(((20.0f * log10(fmax(1.17549435e-38f, fRec24[0]))) + 1.0f), 0.0f)))) + (fConst13 * fRec23[1]));
			float fTemp20 = FastMath.pow(10.0f, (0.0500000007f * fRec23[0]));
			float fTemp21 = (fTemp16 * fTemp20);
			float fTemp22 = fabs(fTemp21);
			fRec26[0] = ((fSlow9 * fTemp1) + (0.999499977f * (fTemp0 * fRec26[1])));
			float fTemp23 = (1.0f - (0.699999988f * fRec26[0]));
			float fTemp24 = ((1.0f / fmin(((0.400000006f * fRec26[0]) + 0.5f), 0.999000013f)) + -2.0f);
			output0[i0] = cast(FAUSTFLOAT)((((fRec0[0] * fTemp22) * (1.0f - cast(float)(2 * (fTemp21 < 0.0f)))) * fTemp23) / ((fTemp24 * (1.0f - fTemp22)) + 1.0f));
			float fTemp25 = (fTemp17 * fTemp20);
			float fTemp26 = fabs(fTemp25);
			output1[i0] = cast(FAUSTFLOAT)((((fRec0[0] * fTemp23) * fTemp26) * (1.0f - cast(float)(2 * (fTemp25 < 0.0f)))) / ((fTemp24 * (1.0f - fTemp26)) + 1.0f));
			fVec0[1] = fVec0[0];
			fRec0[1] = fRec0[0];
			fRec1[1] = fRec1[0];
			IOTA0 = (IOTA0 + 1);
			fRec13[1] = fRec13[0];
			fRec14[1] = fRec14[0];
			fRec15[1] = fRec15[0];
			fRec16[1] = fRec16[0];
			fRec17[1] = fRec17[0];
			fRec18[1] = fRec18[0];
			fRec19[1] = fRec19[0];
			fRec20[1] = fRec20[0];
			fRec11[1] = fRec11[0];
			fRec9[1] = fRec9[0];
			for (int j0 = 11; (j0 > 0); j0 = (j0 - 1)) {
				fVec7[j0] = fVec7[(j0 - 1)];
			}
			fRec7[1] = fRec7[0];
			fRec6[2] = fRec6[1];
			fRec6[1] = fRec6[0];
			fRec21[2] = fRec21[1];
			fRec21[1] = fRec21[0];
			fRec5[1] = fRec5[0];
			iVec8[1] = iVec8[0];
			iRec22[1] = iRec22[0];
			fRec3[1] = fRec3[0];
			fRec2[1] = fRec2[0];
			fRec25[1] = fRec25[0];
			fRec24[1] = fRec24[0];
			fRec23[1] = fRec23[0];
			fRec26[1] = fRec26[0];
		}
	}

}

/***************************END USER SECTION ***************************/

/*******************BEGIN ARCHITECTURE SECTION (part 2/2)***************/

/********************END ARCHITECTURE SECTION (part 2/2)****************/
